#include <sta/bus/spi/device.hpp>

#include <sta/debug/assert.hpp>


namespace sta
{
    SPIDevice::SPIDevice(SPI * intf, GpioPin * csPin)
        : Device{intf}, intf_{intf}, csPin_{csPin}
    {
        STA_ASSERT(intf != nullptr);
        STA_ASSERT(csPin != nullptr);
    }

    const SPISettings & SPIDevice::settings() const
    {
        return intf_->settings();
    }

    void SPIDevice::select()
    {
        csPin_->setState(GpioPinState::GPIO_LOW);
    }

    void SPIDevice::deselect()
    {
        csPin_->setState(GpioPinState::GPIO_HIGH);
    }
} // namespace sta
